﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;

namespace FileExplorerExample
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
		}

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Window2 w2 = new Window2();
            w2.Show();
        }

        private void OpenTest(object sender, RoutedEventArgs e)
        {
            //var testTemplate = new TestTemplate();
            //testTemplate.Show();
        }
	}

	public class FileModel
	{
		private DirectoryFile _main;
		public FileModel()
		{
            FileModelDataSource = new ObservableCollection<DirectoryFile>();

			System.IO.DirectoryInfo topPath = new System.IO.DirectoryInfo(@"C:\foo");
            _main = new DirectoryFile(topPath.FullName, topPath.Name, true,true,null);
			FileModelDataSource.Add(_main);

			foreach (string directory in System.IO.Directory.GetDirectories(@"C:\foo"))
			{
				System.IO.DirectoryInfo directoryInfo = new System.IO.DirectoryInfo(directory);
                DirectoryFile d = new DirectoryFile(directory, directoryInfo.Name, false,true,_main);
				this.LoadChilds(d);
			}

			foreach (string file in System.IO.Directory.GetFiles(@"C:\foo", "*.txt", System.IO.SearchOption.TopDirectoryOnly))
			{
				System.IO.FileInfo fileInfo = new System.IO.FileInfo(file);
                _main.Childs.Add(new DirectoryFile(file, fileInfo.Name,false,false,_main));
			}
		}

        public void LoadChilds(DirectoryFile d)
		{
			foreach (string directory in System.IO.Directory.GetDirectories(d.FullPath))
			{

				System.IO.DirectoryInfo directoryInfo = new System.IO.DirectoryInfo(directory);
                DirectoryFile newDir = new DirectoryFile(directory, directoryInfo.Name, false,true,d);
				string[] files = System.IO.Directory.GetFiles(newDir.FullPath, "*.txt");
				if (files.Length > 0)
				{
					_main.Childs.Add(d);
					d.Childs.Add(newDir);
				}
				LoadChilds(newDir);

			}

			foreach (string file in System.IO.Directory.GetFiles(d.FullPath, "*.txt", System.IO.SearchOption.TopDirectoryOnly))
			{
				System.IO.FileInfo fileInfo = new System.IO.FileInfo(file);
                d.Childs.Add(new DirectoryFile(file, fileInfo.Name,false,false,d));
			}
		}

        public static ObservableCollection<DirectoryFile> FileModelDataSource
		{
			get;
			set;
		}
	}
}
